package com.engine.jucailinkq.attendance.component.page.cmd;

import com.cloudstore.eccom.constant.WeaBoolAttr;
import com.cloudstore.eccom.pc.table.WeaTable;
import com.cloudstore.eccom.pc.table.WeaTableColumn;
import com.cloudstore.eccom.pc.table.WeaTableType;
import com.cloudstore.eccom.result.WeaResultMsg;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailinkq.common.util.DateUtil;
import weaver.general.PageIdConst;
import weaver.general.Util;
import weaver.hrm.User;

import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;

public class GetWorkInfoListCmd extends AbstractCommonCommand<Map<String,Object>> {

    public GetWorkInfoListCmd(Map<String,Object> params, User user){
        this.params=params;
        this.user=user;
    }
    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        String generateDate = Util.null2String(params.get("generateDate"));
        String userId = Util.null2String(params.get("userId"));
        if ("".equals(userId)){
            userId = String.valueOf(user.getUID());
        }
        int diffdays = DateUtil.getDays(generateDate, Calendar.DAY_OF_MONTH);
        String startDate = generateDate + "-01";
        String endDate = generateDate + "-" + diffdays;

        WeaTable table = new WeaTable();
        String pageId = "4073cfcdc177469aa5cc25e7f90f36ef";
        table.setPageID(pageId);
        table.setPageUID(String.format("%s_%s",pageId,user.getUID()));
        String pageSize = PageIdConst.getPageSize(pageId, user.getUID());
        table.setPagesize(pageSize);
        String fields = "t.id,t.rq,t.cqzt,t.cqsc,t.rqlx,t.sfxx ";
        table.setBackfields(fields);

        String fromSql = " from uf_jcl_kq_cqjg t ";
        table.setSqlform(fromSql);

        String sqlWhere = " where ygid="+userId +" and rq>='"+startDate +"' and rq<='"+endDate+"'";

        table.setSqlwhere(sqlWhere);


        table.setSqlprimarykey("id");
        table.getColumns().add(new WeaTableColumn("id").setDisplay(WeaBoolAttr.FALSE));
        table.getColumns().add(new WeaTableColumn("20%", "日期", "rq"));
        table.getColumns().add(new WeaTableColumn("20%", "出勤状态", "cqzt","cqzt","com.engine.jucailinkq.attendance.component.page.transtmethod.Methods.attendaceState"));
        table.getColumns().add(new WeaTableColumn("20%", "出勤时长", "cqsc"));
        table.getColumns().add(new WeaTableColumn("20%", "日期类型", "rqlx","rqlx","com.engine.jucailinkq.attendance.component.page.transtmethod.Methods.getRqlx"));
        table.getColumns().add(new WeaTableColumn("20%", "是否休息", "sfxx","sfxx","com.engine.jucailinkq.attendance.component.page.transtmethod.Methods.checkBox"));


        Map<String, Object> resultMap = new HashMap<>(4);
        WeaResultMsg result = new WeaResultMsg(false);
        result.putAll(table.makeDataResult());
        result.success();
        resultMap.putAll(result.getResultMap());
        return resultMap;
    }
}
