package com.engine.jucailinkq.attendance.workflow.service.impl;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.engine.jucailinkq.attendance.workflow.service.EnterpriseCalendarService;
import com.engine.core.impl.Service;
import com.engine.jucailinkq.common.util.*;
import weaver.general.BaseBean;
import weaver.general.Util;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Author: sy
 * @Description: 企业日历实现类
 * @Date: 2024/4/19
 **/
public class EnterpriseCalendarServiceImpl extends Service implements EnterpriseCalendarService {
    BaseBean bs = new BaseBean();
    @Override
    public Map<String, Object> initCalendar(Map<String, Object> params) {
        Map<String, Object> result = new HashMap<>();
        String yearStr = Util.null2String(params.get("year"));
        String calendarId = Util.null2String(params.get("calendarId"));
        if ("".equals(yearStr) || "".equals(calendarId)) {
            result.put("status", "false");
            result.put("message", "年份和日历必填！");
            return result;
        }
        int year = Integer.parseInt(yearStr);
        //查询所属机构
        String sql = "select * from uf_jcl_kq_rlmc where id = " + calendarId;
        Map<String,Object> dataMain = DbTools.getSqlToMap(sql);
        if (dataMain.size() > 0) {
            //所属机构
            String org = Util.null2String(dataMain.get("szjg"));
            //单双休设置相关信息
            //单双休设置，标准双休-0，单双休-1，单休-2
            String restDaySetting = Util.null2String(dataMain.get("dxzsz"));
            //双周休息日，周一-周日，0-6
            String doubleRestDays = Util.null2String(dataMain.get("dzxxr"));
            //单周休息日，周一-周日，0-6
            String singleRestDays = Util.null2String(dataMain.get("xzxxr"));
            //单双休轮转设置，先单后双-0，先双后单-1
            String restDayTransSetting = Util.null2String(dataMain.get("dxzz"));
            //是否按上一年继续轮转
            String transContinue= Util.null2String(dataMain.get("asynjx"));
            //是否使用农历且带入农历节气信息
            String lunarFlag= Util.null2String(dataMain.get("jqdrmc"));
            //国家信息
            String countrycode="";
            if (dataMain.containsKey("gj")){
                sql = "SELECT bm FROM uf_jcl_kq_tycjsj WHERE id = " + Util.null2String(dataMain.get("gj"));
                Map<String,Object> datagj = DbTools.getSqlToMap(sql);
                if (datagj.size() > 0) {
                    countrycode = Util.null2String(datagj.get("bm"));
                }
            }
            //接口调用
            String conInterface = "0";
            if (dataMain.containsKey("jkdy"))
                conInterface = Util.null2String(dataMain.get("jkdy"));
            //接口优先
            String interfaceFirst = "0";
            if (dataMain.containsKey("jkyx"))
                interfaceFirst = Util.null2String(dataMain.get("jkyx"));
            //农历名称
            String lunarName = "0";
            if (dataMain.containsKey("nl"))
                lunarName = Util.null2String(dataMain.get("nl"));
            if ("1".equals(conInterface)) {
                //=======自动添加日历明细记录===只针对非中国大陆之外的国家或地区执行===========
                /*获取token*/
                String url = "https://api.marcopayroll.com/api:benKoCK8/api/auth/login?email=tigers@tigermedgrp.com&password=mgkH6TsOyCXybl8H";
                String requestStr = "";
                int TIMEOUT = 60000;
                HttpRequest req = HttpUtil.createPost(url).timeout(TIMEOUT).body(requestStr);
                HttpResponse resp = req.execute();
                JSONObject returnJson = JSONObject.parseObject(resp.body());
                String auth_token = returnJson.get("auth_token").toString();
                /*获取指定国家指定日期区间内的节假日信息*/
                url = "https://api.marcopayroll.com/api:benKoCK8/api/public-holiday?country=" + countrycode + "&customer_id=3&start_date=" + yearStr + "/01/01&end_date=" + yearStr + "/12/31";
                req = HttpUtil.createGet(url).timeout(TIMEOUT).body(requestStr).header("Authorization", auth_token);
                resp = req.execute();
                returnJson = JSONObject.parseObject(resp.body());
                JSONArray jsonArray = JSONArray.parseArray(JSONObject.parseObject(returnJson.get("public_holiday").toString()).get("items").toString());
                JSONObject holidayitem;
                String start_date, end_date;
                String holidayname_zh = "";
                String holidayname_en = "";
                JSONArray dictionary;
                List<Map<String, Object>> holidayInfoList = new ArrayList<>();
                Map<String, Object> holidayInfo = new HashMap<>();
                String condition = " mainid = " + calendarId + " and glrq between '" + yearStr + "-01-01' and '" + yearStr + "-12-31'";
                List<String> dbitems = CommonUtil.getUniqueItems("uf_jcl_kq_rlmc_dt1","glrq",condition);
                for (int i = 0; i < jsonArray.size(); i++) {
                    holidayitem = jsonArray.getJSONObject(i);
                    start_date = holidayitem.get("start_date").toString();
                    end_date = holidayitem.get("end_date").toString();
                    dictionary = JSONArray.parseArray(holidayitem.get("dictionary").toString());
                    for (int j = 0; j < dictionary.size(); j++) {
                        if (!"".equals(dictionary.getJSONObject(j).get("value"))) {
                            switch (dictionary.getJSONObject(j).get("lang").toString()) {
                                case "ZH":
                                    holidayname_zh = dictionary.getJSONObject(j).get("value").toString();
                                    break;
                                case "EN":
                                    holidayname_en = dictionary.getJSONObject(j).get("value").toString();
                                    break;
                                default:
                                    break;
                            }
                        }
                    }
                    if (start_date.equals(end_date)) {
                        if (!dbitems.contains(start_date)) {
                            holidayInfo = createHolidayInfo(calendarId, start_date, holidayname_zh, holidayname_en);
                            holidayInfoList.add(holidayInfo);
                            dbitems.add(start_date);
                        }
                    } else {
                        int m = DateUtil.getBetWeenDays(start_date, end_date);
                        for (int n = 0; n < m; n++) {
                            String tmpdate = DateUtil.AfterDay(start_date, n);
                            if (!dbitems.contains(tmpdate)) {
                                holidayInfo = createHolidayInfo(calendarId, tmpdate, holidayname_zh, holidayname_en);
                                holidayInfoList.add(holidayInfo);
                                dbitems.add(tmpdate);
                            }
                        }
                    }
                }
                boolean insertSign = CommonUtil.insertBatch(holidayInfoList, "uf_jcl_kq_rlmc_dt1");
                bs.writeLog("insertholidaydetail : " + insertSign);
                //=======自动添加日历明细记录==============
            }

            Map<String,Map<String,Object>> holidayMap = DealDetail(calendarId, yearStr, lunarFlag, lunarName);
            //在单双周轮换时，判断第一周的休息日情况
            boolean doubleRestSign = true;
            if (restDaySetting.equals("1")) {
                doubleRestSign = restDayTransSetting.equals("1");
                if (transContinue.equals("1")) {
                    doubleRestSign = checkFirstWeekRest(year, calendarId, doubleRestSign);
                }
            }
            //查询formmodeid
            Map<String,String> formModeIdMap = Utils.getFormmodeIdMap();
            String formModeId = formModeIdMap.get("uf_jcl_kq_rlxx");
            Calendar calendar = Calendar.getInstance();
            List<Map<String, Object>> dateInfoList = new ArrayList<>();
            Map<String, Object> dateInfo;
            for (int i = 1; i <= 12; i++) {
                calendar.set(year, i - 1, 1);
                int daysInMonth = calendar.getActualMaximum(Calendar.DAY_OF_MONTH);

                for (int day = 0; day < daysInMonth; day++) {
                    dateInfo = new HashMap<>();
                    dateInfo = createDateInfo(calendar, lunarFlag, lunarName);
                    dateInfo.put("formmodeid",formModeId);
                    dateInfo.put("modeuuid", UUID.randomUUID().toString());
                    dateInfo.put("modedatacreater","1");
                    dateInfo.put("modedatacreatertype","0");
                    dateInfo.put("modedatacreatedate", DateUtil.getCurrentTime().split(" ")[0]);
                    dateInfo.put("modedatacreatetime",DateUtil.getCurrentTime().split(" ")[1]);
                    dateInfo.put("rlmc", calendarId);
                    dateInfo.put("nd", yearStr);
                    dateInfo.put("szjg", org);
                    //判断日历设置是否有单双休相关数值，并修改日期类型
                    //双休时，判断双休休息日是否包括当前日期的星期值，休息日类型低于节假日类型
                    if ("0".equals(restDaySetting) && doubleRestDays.contains(dateInfo.get("xq").toString()) && !"1".equals(dateInfo.get("rqlx"))) {
                        dateInfo.put("rqlx", "2");
                    }
                    //单休时，判断单休休息日是否包括当前日期的星期值，休息日类型低于节假日类型
                    else if ("2".equals(restDaySetting) && singleRestDays.contains(dateInfo.get("xq").toString()) && !"1".equals(dateInfo.get("rqlx"))) {
                        dateInfo.put("rqlx", "2");
                    }
                    //单双休时，判断当前周是单休还是双休，并在各自得情况下判断休息日是否包括当前日期的星期值，休息日类型低于节假日类型
                    else if ("1".equals(restDaySetting)) {
                        if (doubleRestSign && doubleRestDays.contains(dateInfo.get("xq").toString()) && !"1".equals(dateInfo.get("rqlx"))) {
                            dateInfo.put("rqlx", "2");
                        } else if (!doubleRestSign && singleRestDays.contains(dateInfo.get("xq").toString()) && !"1".equals(dateInfo.get("rqlx"))) {
                            dateInfo.put("rqlx", "2");
                        }
                        //单双休时，每一周都要轮换单双休状态
                        if ("6".equals(dateInfo.get("xq"))) {
                            doubleRestSign = !doubleRestSign;
                        }
                    }
                    dateInfo.put("rqlx", "0");
                    dateInfo.put("bz", "");
                    dateInfo.put("mc", "");
                    if (holidayMap.containsKey(dateInfo.get("rq"))){
                        dateInfo.put("rqlx", holidayMap.get(dateInfo.get("rq")).get("rqlx"));
                        dateInfo.put("bz", holidayMap.get(dateInfo.get("rq")).get("bz"));
                        dateInfo.put("mc", holidayMap.get(dateInfo.get("rq")).get("mc"));
                    }
                    if (holidayMap.containsKey(dateInfo.get("nlrq"))){
                        dateInfo.put("rqlx", holidayMap.get(dateInfo.get("nlrq")).get("rqlx"));
                        dateInfo.put("bz", holidayMap.get(dateInfo.get("nlrq")).get("bz"));
                        dateInfo.put("mc", holidayMap.get(dateInfo.get("nlrq")).get("mc"));
                    }
                    if (holidayMap.containsKey(dateInfo.get("mc"))){
                        dateInfo.put("rqlx", holidayMap.get(dateInfo.get("mc")).get("rqlx"));
                        dateInfo.put("bz", holidayMap.get(dateInfo.get("mc")).get("bz"));
                        dateInfo.put("mc", holidayMap.get(dateInfo.get("mc")).get("mc"));
                    }
                    dateInfoList.add(dateInfo);
                    calendar.add(Calendar.DAY_OF_MONTH, 1);
                }
            }
            //删除老数据
            String delSql = "delete from uf_jcl_kq_rlxx where rlmc = " + calendarId + " and nd = " + yearStr;
            boolean delSign = DbTools.update(delSql);
            bs.writeLog("delSign : " +  delSign + ", delSql : " + delSql);
            //插入新数据
            String tableName = "uf_jcl_kq_rlxx";
            if (dateInfoList.size() > 0) {
                bs.writeLog("入库开始---");
                boolean insertSign = CommonUtil.insertBatch(dateInfoList, tableName);
                bs.writeLog("insertSign : " + insertSign);
                result.put("status", String.valueOf(insertSign));
                result.put("message", insertSign ? "初始化成功" : "初始化失败， 插入新数据未成功");
            } else {
                result.put("status", "false");
                result.put("message", "初始化失败, 未生成新数据");
            }

        } else {
            result.put("status", "false");
            result.put("message", "初始化失败, 日历信息不存在");
        }
        return result;
    }

    private boolean checkFirstWeekRest(int year, String calendarId, boolean doubleRestSign) {
        Calendar calendar =Calendar.getInstance();
        calendar.set(year, Calendar.JANUARY, 1);
        String firstDayWeek = getWeek(calendar);
        int lastYear = year -1;
        int firstIndex = Integer.parseInt(firstDayWeek);
        //获取目标年度第一天所在周的之前的一周日期
        List<String> lastWeekDays = new ArrayList<>();
        for (int i = 1; i <= 7; i++) {
            lastWeekDays.add(lastYear + "-12-" + (31 - firstIndex));
            firstIndex++;
        }
        //查询上一步中查询的日期中有几个公休日
        String sql = "select * from uf_jcl_kq_rlxx where rlmc = " + calendarId + " and nd =" + lastYear+ " and rq in ('"+String.join("','",lastWeekDays)+"')";
        List<Map<String,Object>> data = DbTools.getSqlToList(sql);
        int restDayNum = 0;
        if (data.size() > 0) {
            for (Map<String,Object> map : data) {
                if (Util.null2String(map.get("rqlx")).equals("2")) {
                    restDayNum++;
                }
            }
            return restDayNum < 2;
        } else {
            return doubleRestSign;
        }
    }

    /**
     * 根据日历信息明细设置特定日期日历
     * @param pCalendarId 日历信息ID
     * @param pYearStr 年度
     * @param pLunarFlag 是否农历检查
     * @return 各特定日期信息
     */
    private Map<String,Map<String,Object>> DealDetail(String pCalendarId, String pYearStr, String pLunarFlag, String pLunarName) {
        String sql = "SELECT * FROM UF_JCL_KQ_RLMC_DT1 WHERE MAINID = " + pCalendarId + " AND ((lx = 0 AND ((rqczz = '0' AND glrq LIKE '" + pYearStr + "%') OR rqczz != '0')) OR lx = 1) order by sjly";
        List<Map<String, Object>> dataDetail = DbTools.getSqlToList(sql);
        String row_mc = "";//名称
        String row_rqlx = "";//日期类型：0：工作日；1：节假日；2：公休日；3：调休日；4：调班日
        String row_bzsm = "";//备注说明
        String row_lx = "";//类型:0:公历；1：农历
        String row_glrq = "";//公历日期
        int row_yf = 0;//月份
        String row_rqczz = "";//日期参照值：0：年-月-日；1：月-日；2：月-周
        String row_sjly = "";//数据来源
        int row_dydjr = 0;//当月第几日
        int row_dydjz = 0;//当月第几周
        int row_dzxqj = 0;//当周星期几
        int row_jq=0;//节气
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Calendar calendar = Calendar.getInstance();
        Map<String, Object> row_data = new HashMap<>();
        Map<String, Map<String, Object>> rows = new HashMap<>();
        for (Map<String, Object> holidayMap : dataDetail) {
            row_glrq = Util.null2String(holidayMap.get("glrq"));//公历日期
            row_mc = holidayMap.get("mc").toString();
            row_lx = holidayMap.get("lx").toString();
            row_rqlx = holidayMap.get("rqlx").toString();
            row_bzsm = Util.null2String(holidayMap.get("bzsm"));
            row_rqczz = Util.null2String(holidayMap.get("rqczz"));
            row_sjly = Util.null2String(holidayMap.get("sjly"));
            switch (row_rqczz) {
                case "0":
                    //年-月-日 ***************农历不支持此逻辑
                    break;
                case "1":
                    //月-日 2024-12-13
                    row_yf = Integer.parseInt(holidayMap.get("yf").toString());
                    row_dydjr = Integer.parseInt(holidayMap.get("dydjr").toString());
                    calendar = Calendar.getInstance();
                    if (row_lx.equals("0")) {
                        //公历处理逻辑
                        if (row_dydjr > 0) {
                            calendar.set(Integer.parseInt(pYearStr), row_yf, row_dydjr);
                        } else {
                            calendar.set(Integer.parseInt(pYearStr), row_yf, 1);
                            calendar.add(Calendar.MONTH, 1);
                            calendar.add(Calendar.DATE, row_dydjr);
                        }
                        row_glrq = sdf.format(calendar.getTime());
                    } else {
                        //农历处理逻辑
                        //考虑到只有目前除夕是特殊的，取腊月的最后一天，所以对除夕做特殊处理
                        if (row_dydjr > 0) {
                            row_glrq = sdf.format(LunarCalendar.chineseMonthNumber[row_yf]+LunarCalendar.getChinaDayString(row_dydjr));
                        }else{
                            calendar.set(Integer.parseInt(pYearStr), 1,1);
                            LunarCalendar lunarCalendar = new LunarCalendar(calendar);
                            int monthDays = LunarCalendar.monthDays(lunarCalendar.getYear(), 12);
                            row_glrq = LunarCalendar.chineseMonthNumber[row_yf] + "月" + LunarCalendar.getChinaDayString(monthDays+1+row_dydjr);
                        }
                    }
                    break;
                case "2":
                    //月-周 ***************农历不支持此逻辑
                    calendar = Calendar.getInstance();
                    row_yf = Integer.parseInt(holidayMap.get("yf").toString());
                    calendar.set(Integer.parseInt(pYearStr), row_yf, 1);
                    int dayOfWeek = Integer.parseInt(getWeek(calendar));//周一-周日为0-6
                    row_dydjz = Integer.parseInt(holidayMap.get("dydjz").toString());
                    row_dzxqj = Integer.parseInt(holidayMap.get("dzxqj").toString());
                    if (row_dzxqj > dayOfWeek) {
                        calendar.add(Calendar.DATE, row_dzxqj - dayOfWeek);
                    } else {
                        calendar.add(Calendar.DATE, row_dzxqj + 7 - dayOfWeek);
                    }
                    calendar.add(Calendar.DATE, (row_dydjz - 1) * 7);
                    row_glrq = sdf.format(calendar.getTime());
                    break;
                case "3":
                    row_jq = Integer.parseInt(holidayMap.get("nlrq").toString());
                    String[] principleTermNames = {"立春","雨水","惊蛰","春分","清明","谷雨","立夏","小满","芒种","夏至","小暑","大暑","立秋","处暑","白露","秋分","寒露","霜降","立冬","小雪","大雪","冬至","小寒","大寒"};
                    row_glrq = principleTermNames[row_jq];
                    break;
                default:
                    break;
            }
            row_data = new HashMap<>();
            row_data.put("mc", row_mc);//名称
            row_data.put("rqlx", row_rqlx);//日期类型
            row_data.put("bz", row_bzsm);//备注
            row_data.put("rq", row_glrq);//公历日期
            row_data.put("sjly", row_sjly);//数据来源
            rows.put(row_glrq, row_data);
        }
        return rows;
    }

    private Map<String, Object> createHolidayInfo(String calendarid, String date, String zh_name, String en_name) {
        Map<String, Object> holidayInfo = new HashMap<>();
        holidayInfo.put("mainid",calendarid);
        holidayInfo.put("lx",0);//日历类型：0：公历；1：农历
        holidayInfo.put("rqczz",0);//日期参照值：0：年-月-日；1：月-日；2：月-周
        holidayInfo.put("rqlx",1);//日期类型：0：工作日；1：节假日；2：公休日；3：调休日；4：调班日
        holidayInfo.put("glrq",date);
        holidayInfo.put("mc",zh_name);//名称
        holidayInfo.put("sjly","0");//名称
        //holidayInfo.put("nlrq","");//农历日期文本
        //holidayInfo.put("dydjr","");//当月第几日
        //holidayInfo.put("dydjz","");//当月第几周
        //holidayInfo.put("dzxqj",calendarId);//当周星期几：0：星期一；1：星期二；2：星期三；6：星期日
        return  holidayInfo;
    }

    private Map<String, Object> createDateInfo(Calendar calendar, String solarTerms, String lunarName) {
        Map<String, Object> dateInfo = new HashMap<>();
        // 获取阳历年-月-日
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        // 使用SimpleDateFormat格式化Calendar中的日期
        String solarDate  = sdf.format(calendar.getTime());
        //获取农历日期
        LunarCalendar lunarCalendar = new LunarCalendar(calendar);
        String lunarDate = lunarCalendar.traditionLunarDay();
        //获取目标日期是周几, 此功能中周一-周日为0-6
        String weekIndex = getWeek(calendar);
        //获取日期特定名称，节气或节日
        String specialDay = "";
        //判断日期是否为节气
        SolarTermsUtil solarTermsUtil = new SolarTermsUtil(calendar);
        String termInfo = solarTermsUtil.getSolartermsMsg();
        if (!termInfo.equals("")) {
            specialDay = termInfo.replace(" ", "");
        }
        /* 此部分逻辑转移到读取日历信息明细
        //判断日期是否为节日
        String holidayInfo = getHolidayInfo(calendar, lunarCalendar);
        if (!holidayInfo.equals("")) {
            specialDay = specialDay + holidayInfo;
        }
        //判断日期类型
        String dayType = getDayType(weekIndex, specialDay);
         */
        dateInfo.put("rq", solarDate);
        //依据是否节气信息，设置日期名称
        if (solarTerms.equals("1")) {
            dateInfo.put("mc", specialDay.equals("") ? null : specialDay);
        }else{
            dateInfo.put("mc", "");
        }
        //依据是否农历日期，设置农历日期字段值
        if (lunarName.equals("1")) {
            dateInfo.put("nlrq", lunarDate);
        }else{
            dateInfo.put("nlrq", "");
        }
        dateInfo.put("xq", weekIndex);
        dateInfo.put("bz", "");
        return dateInfo;
    }

    private String getDayType(String weekIndex, String specialDay) {
        String dayType = "0";
        List<String> realHolidayList = new ArrayList<>();
        realHolidayList.add("春节");
        realHolidayList.add("元旦节");
        realHolidayList.add("劳动节");
        realHolidayList.add("国庆节");
        realHolidayList.add("端午节");
        realHolidayList.add("中秋节");
        realHolidayList.add("清明");
        for (String holiday : realHolidayList) {
            if (specialDay.contains(holiday)) {
                dayType = "1";
                break;
            }
        }
//        if (!"1".equals(dayType)) {
//            if ("5".equals(weekIndex) || "6".equals(weekIndex)) {
//                dayType = "2";
//            }
//        }
        return dayType;
    }

    private String getHolidayInfo(Calendar calendar, LunarCalendar lunarCalendar) {
        String holidayInfo = "";
        //公历节日
        int solarMonth = calendar.get(Calendar.MONTH) + 1; // Calendar.MONTH 从0开始计数
        int solarDay = calendar.get(Calendar.DAY_OF_MONTH);
        if (solarMonth == 1 && solarDay == 1) {
            holidayInfo = holidayInfo + "元旦节";
        }
        if (solarMonth == 2 && solarDay == 14) {
            holidayInfo = holidayInfo + "情人节";
        }
        if (solarMonth == 3 && solarDay == 8) {
            holidayInfo = holidayInfo + "妇女节";
        }
        if (solarMonth == 3 && solarDay == 12) {
            holidayInfo = holidayInfo + "植树节";
        }
        if (solarMonth == 4 && solarDay == 1) {
            holidayInfo = holidayInfo + "愚人节";
        }
        if (solarMonth == 5 && solarDay == 1) {
            holidayInfo = holidayInfo + "劳动节";
        }
        if (solarMonth == 5 && solarDay == 4) {
            holidayInfo = holidayInfo + "中国青年节";
        }
        if (solarMonth == 6 && solarDay == 1) {
            holidayInfo = holidayInfo + "儿童节";
        }
        if (solarMonth == 7 && solarDay == 1) {
            holidayInfo = holidayInfo + "建党节";
        }
        if (solarMonth == 8 && solarDay == 1) {
            holidayInfo = holidayInfo + "建军节";
        }
        if (solarMonth == 9 && solarDay == 10) {
            holidayInfo = holidayInfo + "教师节";
        }
        if (solarMonth == 10 && solarDay == 1) {
            holidayInfo = holidayInfo + "国庆节";
        }
        //农历节日，春节
        int lunarMonth = lunarCalendar.getMonth();
        int lunarDay = lunarCalendar.getDay();

        if (lunarMonth == 1 && lunarDay == 1) {
            holidayInfo = holidayInfo + "春节";
        }
        if (lunarMonth == 1 && lunarDay == 15) {
            holidayInfo = holidayInfo + "元宵节";
        }
        if (lunarMonth == 5 && lunarDay == 5) {
            holidayInfo = holidayInfo + "端午节";
        }
        if (lunarMonth == 7 && lunarDay == 7) {
            holidayInfo = holidayInfo + "七夕节";
        }
        if (lunarMonth == 8 && lunarDay == 15) {
            holidayInfo = holidayInfo + "中秋节";
        }
        if (lunarMonth == 9 && lunarDay == 9) {
            holidayInfo = holidayInfo + "重阳节";
        }
        //除夕特殊处理
        if (lunarMonth == 12) {
            int monthDays = LunarCalendar.monthDays(lunarCalendar.getYear(), lunarMonth);
            if (monthDays == lunarDay) {
                holidayInfo = holidayInfo + "除夕";
            }
        }
        return holidayInfo;
    }

    //根据日期取得星期几，
    public static String getWeek(Calendar cal){
        //日历详细表中字段xq枚举值与该方法中的周几值存在差值，故存在相关处理逻辑
        int weekIndex = cal.get(Calendar.DAY_OF_WEEK) - 2;
        if(weekIndex<0){
            weekIndex = 6;
        }
        return String.valueOf(weekIndex);
    }
}
